<!doctype html>
<html xmlns:th="http://www.thymeleaf.org">
<head>
    <base th:href="${#request.getContextPath() + '/'}">
    <meta charset="utf-8">
    <meta name="renderer" content="webkit">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, appversion-scalable=0">
    <link rel="stylesheet" href="assets/fonts/font-awesome/css/font-awesome.css"/>
    <link rel="stylesheet" type="text/css" href="assets/js/vendor/viewer/viewer.min.css">
    <link rel="stylesheet" href="assets/layuiadmin/layui/css/layui.css" media="all">
    <link rel="stylesheet" href="assets/layuiadmin/style/admin.css" media="all">
</head>
<body>
<div class="layui-fluid layui-anim layui-anim-fadein">
    <div class="layui-row">
        <div class="layui-col-md12">
            <div class="layui-card">
                <div class="layui-card-body">
                    <div class="test-table-reload-btn" style="margin-bottom: 10px;">
                        <div class="layui-inline">
                            <input type="text" id="keywords" class="layui-input search-item" placeholder="输入关键字">
                        </div>
                        <button type="button" id="search" class="layui-btn layui-btn-sm">
                            <i class="fa fa-lg fa-search"></i> 搜索
                        </button>
                    </div>
                    <table class="layui-hide" id="dataTable" lay-filter="dataTable"></table>
                    <!-- 表头按钮组 -->
                    <script type="text/html" id="headerToolBar">
                        <div class="layui-btn-group">
                            <button type="button" class="layui-btn layui-btn-sm" lay-event="save">
                                <i class="fa fa-lg fa-plus"></i> 新增
                            </button>
                            <button type="button" class="layui-btn layui-btn-normal layui-btn-sm" lay-event="update">
                                <i class="fa fa-lg fa-edit"></i> 编辑
                            </button>
                            <button type="button" class="layui-btn layui-btn-danger layui-btn-sm" lay-event="remove">
                                <i class="fa fa-lg fa-trash"></i> 删除
                            </button>
                        </div>
                    </script>
                </div>
            </div>
        </div>
    </div>
</div>
<script src="assets/layuiadmin/layui/layui.js"></script>
<script src="assets/js/vendor/viewer/viewer.min.js"></script>
<script>
    layui.config({
        base: 'assets/layuiadmin/'
    }).extend({
        index: 'lib/index'
    }).use(['index', 'table', 'laydate'], function() {
        var $ = layui.$;
        var $win = $(window);
        var table = layui.table;
        var admin = layui.admin;
        var laydate = layui.laydate;
        var resizeTimeout = null;
        var tableUrl = 'api/appversion/listpage';

        // 初始化表格
        function initTable() {
            table.render({
                elem: '#dataTable',
                id: 'dataTable',
                url: top.restAjax.path(tableUrl, []),
                width: admin.screen() > 1 ? '100%' : '',
                height: $win.height() - 90,
                limit: 20,
                limits: [20, 40, 60, 80, 100, 200],
                toolbar: '#headerToolBar',
                request: {
                    pageName: 'page',
                    limitName: 'rows'
                },
                cols: [
                    [
                        {type:'checkbox', fixed: 'left'},
                        {field:'rowNum', width:80, title: '序号', fixed: 'left', align:'center', templet: '<span>{{d.LAY_INDEX}}</span>'},
                        {field:'appName', width:140, title: 'APP名称', align:'center',
                            templet: function(item) {
                                return '<a href="javascript:void(0);" lay-event="downLoadFile">'+ item.appName +'</a>';
                            }
                        },
                        {field:'appSummary', width:140, title: 'APP说明', align:'center'},
                        {field:'appVersion', width:80, title: '版本号', align:'center'},
                        {field:'appApiLock', width: 120, title: '接口版本锁定', align:'center',
                            templet: function(item) {
                                var value = '<button type="button" class="layui-btn layui-btn-warn layui-btn-sm" lay-event="appApiLock">锁定</button>';
                                if(item.appApiLock == 1) {
                                    value = '<button type="button" class="layui-btn layui-btn-danger layui-btn-sm" lay-event="appApiUnLock">解锁</button>';
                                }
                                return value;
                            }
                        },
                        {field:'appQRCode', width: 80, title: '二维码', align:'center',
                            templet: function(item) {
                                var value = '<img id="qrCode_'+ item.appVersionId +'" src="api/appversion/downloadqrcode/'+ item.appVersionId +'" style="width:25px;height:25px;cursor:pointer;"/>';
                                setTimeout(function() {
                                    new Viewer(document.getElementById('qrCode_'+ item.appVersionId));
                                }, 50);
                                return value;
                            }
                        },
                        {field:'isNecessary', width: 90, title: '强制更新', align:'center',
                            templet: function(item) {
                                var value = '否';
                                if(item.isNecessary == 1) {
                                    value = '是';
                                }
                                return value;
                            }
                        },
                        {field:'isRelease', width: 100, title: '强制发布', align:'center',
                            templet: function(item) {
                                var value = '<button class="layui-btn layui-btn-sm layui-btn-normal" lay-event="releaseApp">点击发布</button>';
                                if(item.isRelease == 1) {
                                    value = '<button class="layui-btn layui-btn-sm layui-btn-danger" lay-event="unReleaseApp">取消发布</button>';
                                }
                                return value;
                            }
                        },
                        {field:'appDownloadCount', width: 100, title: '下载次数', align:'center'},
                        {field:'appDownloadUrl', width: 300, title: '下载链接', align:'center',
                            'templet': function(item) {
                                return '/app/appversion/download/'+ item.appVersionId;
                            }
                        },
                    ]
                ],
                page: true,
                parseData: function(data) {
                    return {
                        'code': 0,
                        'msg': '',
                        'count': data.total,
                        'data': data.rows
                    };
                },
            });
        }
        // 重载表格
        function reloadTable(currentPage) {
            table.reload('dataTable', {
                url: top.restAjax.path(tableUrl, []),
                where: {
                    keywords: $('#keywords').val(),
                },
                page: {
                    curr: currentPage
                },
                height: $win.height() - 90,
            });
        }
        // 初始化日期
        function initDate() {}
        // 删除
        function removeData(ids) {
            top.dialog.msg(top.dataMessage.delete, {
                time: 0,
                btn: [top.dataMessage.button.yes, top.dataMessage.button.no],
                shade: 0.3,
                yes: function (index) {
                    top.dialog.close(index);
                    var layIndex;
                    top.restAjax.delete(top.restAjax.path('api/appversion/remove/{ids}', [ids]), {}, null, function (code, data) {
                        top.dialog.msg(top.dataMessage.deleteSuccess, {time: 1000}, function () {
                            reloadTable();
                        });
                    }, function (code, data) {
                        top.dialog.msg(data.msg);
                    }, function () {
                        layIndex = top.dialog.msg(top.dataMessage.deleting, {icon: 16, time: 0, shade: 0.3});
                    }, function () {
                        top.dialog.close(layIndex);
                    });
                }
            });
        }
        initTable();
        initDate();
        // 事件 - 页面变化
        $win.on('resize', function() {
            clearTimeout(resizeTimeout);
            resizeTimeout = setTimeout(function() {
                reloadTable();
            }, 500);
        });
        // 事件 - 搜索
        $(document).on('click', '#search', function() {
            reloadTable(1);
        });
        // 事件 - 增删改
        table.on('toolbar(dataTable)', function(obj) {
            var layEvent = obj.event;
            var checkStatus = table.checkStatus('dataTable');
            var checkDatas = checkStatus.data;
            if(layEvent === 'save') {
                layer.open({
                    type: 2,
                    title: false,
                    closeBtn: 0,
                    area: ['100%', '100%'],
                    shadeClose: true,
                    anim: 2,
                    content: top.restAjax.path('route/appversion/save', []),
                    end: function() {
                        reloadTable();
                    }
                });
            } else if(layEvent === 'update') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectEdit);
                } else if(checkDatas.length > 1) {
                    top.dialog.msg(top.dataMessage.table.selectOneEdit);
                } else {
                    layer.open({
                        type: 2,
                        title: false,
                        closeBtn: 0,
                        area: ['100%', '100%'],
                        shadeClose: true,
                        anim: 2,
                        content: top.restAjax.path('route/appversion/update?appVersionId={id}', [checkDatas[0].appVersionId]),
                        end: function() {
                            reloadTable();
                        }
                    });
                }
            } else if(layEvent === 'remove') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectDelete);
                } else {
                    var ids = '';
                    for(var i = 0, item; item = checkDatas[i++];) {
                        if(i > 1) {
                            ids += '_';
                        }
                        ids += item.appVersionId;
                    }
                    removeData(ids);
                }
            }
        });
        // 解锁和绑定
        function appApiLock(appVersionId, appApiLock) {
            top.dialog.confirm('确定修改锁定状态吗？', function() {
                var loadLayerIndex;
                top.restAjax.put(top.restAjax.path('api/appversion/update-api-lock/{appVersionId}/{appApiLock}', [appVersionId, appApiLock]), self.formObject, null, function(code, data) {
                    top.dialog.msg(top.dataMessage.updated, {time: 1000});
                    reloadTable();
                }, function(code, data) {
                    top.dialog.msg(data.msg);
                }, function() {
                    loadLayerIndex = top.dialog.msg(top.dataMessage.updating, {icon: 16, time: 0, shade: 0.3});
                }, function() {
                    top.dialog.close(loadLayerIndex);
                });
            });
        }
        table.on('tool(dataTable)', function(obj) {
            var layEvent = obj.event;
            var data = obj.data;
            if(layEvent === 'downLoadFile') {
                top.dialog.confirm('确定下载吗？', function() {
                    window.open('route/file/download/false/'+ data.appFile);
                });
            } else if(layEvent === 'appApiLock') {
                appApiLock(data.appVersionId, '1');
            } else if(layEvent === 'appApiUnLock') {
                appApiLock(data.appVersionId, '0');
            } else if(layEvent === 'releaseApp') {
                top.dialog.confirm('确定发布该APP吗？发布后，APP可以正常下载。', function() {
                    top.restAjax.put(top.restAjax.path('api/appversion/update-release/{appVersionId}', [data.appVersionId]), {}, null, function(code, data) {
                        top.dialog.msg('发布成功');
                        reloadTable();
                    }, function(code, data) {
                        top.dialog.msg(data.msg);
                    });
                });
            } else if(layEvent === 'unReleaseApp') {
                top.dialog.confirm('确定取消发布该APP吗？取消后，APP将无法下载', function() {
                    top.restAjax.put(top.restAjax.path('api/appversion/update-unrelease/{appVersionId}', [data.appVersionId]), {}, null, function(code, data) {
                        top.dialog.msg('取消成功');
                        reloadTable();
                    }, function(code, data) {
                        top.dialog.msg(data.msg);
                    });
                });
            }
        });
        // 事件-排序
        table.on('sort(dataTable)', function(obj) {
            table.reload('dataTable', {
                initSort: obj,
                where: {
                    sort: obj.field,
                    order: obj.type
                }
            });
        });
    });
</script>
</body>
</html>